# DI to MQTT publisher for MA-X3xx

## このアプリケーションについて

指定された MA-X3xx の DI 信号を監視し、変化があった場合に MQTT Broker に対して JSON 形式で
DI の状態を publish するサンプルアプリケーションです。

    root@metis:~# /tmp/di_mqtt -c /tmp/di_mqtt.conf

別の端末で MQTT Broker に subscribe しておきます。

    root@metis:~# nmqtt_sub -p 51883 -t 'DI'

DI を変化させると、指定した DI 全ての情報が publish されます。

    root@metis:~# nmqtt_sub -p 51883 -t 'DI'
    DI: {"timestamp":1687340678802,"state":{"DI_10":0,"DI_3":1,"DI_8":0,"DI_0":0,"DI_5":0,"DI_4":0,"DI_6":0,"DI_9":0,"DI_11":0,"DI_7":0,"DI_1":0,"DI_2":0}}
    DI: {"timestamp":1687340683524,"state":{"DI_10":0,"DI_3":1,"DI_8":0,"DI_0":1,"DI_5":0,"DI_4":1,"DI_6":1,"DI_9":0,"DI_11":0,"DI_7":0,"DI_1":0,"DI_2":1}}
    DI: {"timestamp":1687340775994,"state":{"DI_10":0,"DI_3":1,"DI_8":0,"DI_0":1,"DI_5":1,"DI_4":1,"DI_6":1,"DI_9":0,"DI_11":0,"DI_7":1,"DI_1":1,"DI_2":1}}
    ...

この情報を SORACOM Harvest などに送信することで、DI の状態をリモートで監視することができます。

## How to Build

[Nim](http://nim-lang.org/) と aarch64 用クロスコンパイラが必要です。\
ビルドは nimble を用いた通常の方法でビルドします。\
標準で ARM 用バイナリを出力する設定にしてあります。

    $ nimble build -d:release

## Options

    root@metis:~# /tmp/di_mqtt --help
    DI-MQTT Emitter

    Usage:
      DI-MQTT Emitter [options]

    Options:
      -c, --config=CONFIG        config file path
      -h, --help                 Show this help

## Config File

    [MQTT]
    HOST = localhost
    PORT = 51883
    TOPIC = DI

    [DI]
    DI_0 = Raw
    DI_1 = Raw
    DI_2 = Raw
    DI_3 = Filtered
    DI_4 = Raw
    DI_5 = Raw
    DI_6 = Raw
    DI_7 = Raw
    DI_8 = Raw
    DI_9 = Raw
    DI_10 = Raw
    DI_11 = Raw
